#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdlib.h>
#include "ui.h"

int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPSTR     lpCmdLine,
                   int       nCmdShow)
{
	MSG msg;

	if (__argc != 1)
	{
		/* Rename main because gcc will use it instead of WinMain even with -mwindows */
		extern int mame_main(int, char**);
		return mame_main(__argc, __argv);
	}

	if (!Win32UI_init(hInstance, lpCmdLine, nCmdShow))
		return 1;

	for (;;)
	{
		/* phase1: check to see if we can do idle work */
		while (g_bIdleWork && !PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE))
		{
			/* call OnIdle while idle_work */
			OnIdle();
		}

		/* phase2: pump messages while available */
		do
		{
			/* pump message, but quit on WM_QUIT */
			if (!PumpMessage())
			{
				Win32UI_exit();
				return msg.wParam;
			}
		}
		while (PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE));
	}

	return 0;
}

